﻿using System.Linq;
using System.Windows.Controls;
using Telerik.Windows.Data;
using SilverlightApplication1.Web;
using System.ServiceModel.DomainServices.Client;
using Telerik.Windows.Controls.DomainServices;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var context = new NorthwindDomainContext();
            var query = context.GetOrder_DetailsQuery().OrderBy(o => o.OrderID);

            var view = new VirtualQueryableCollectionView() { LoadSize = 10, VirtualItemCount = 100 };
            view.ItemsLoading += (s, e) =>
            {
                var queryToLoad = query.IncludeTotalCount(true).Sort(view.SortDescriptors).Where(view.FilterDescriptors).Skip(e.StartIndex).Take(e.ItemCount);

                context.Load<Order_Detail>(queryToLoad).Completed += (sender, args) =>
               {
                   var lo = (LoadOperation)sender;
                   if (lo.TotalEntityCount != -1 && lo.TotalEntityCount != view.VirtualItemCount)
                   {
                       view.VirtualItemCount = lo.TotalEntityCount;
                   }

                   view.Load(e.StartIndex, lo.Entities);
               };
            };

            DataContext = view;
        }
    }
}
